#!/usr/bin/perl

####################################################################################
#
# TUOTENIMI:    Sport LeagueResult System / Resulttia Solutions
# VERSIO:       1.0.20150301
# PIVITETTY:   01.03.2015
#
# VAATIMUKSET:  Perl-tuki
#
####################################################################################
#
# Copyright (c) 2001-2015 Resulttia Solutions
# Kaikki oikeudet pidtetn.
#
# http://www.resulttia.fi
# info@resulttia.fi
#
####################################################################################
#
# Ohjelman kyttoikeuden omistaa:
# Resulttia Solutions
#
# Internet-osoite, jota kyttoikeus koskee:
# http://www.junnubilisliiga.fi
#
####################################################################################
#
# Ohjelman tai sen yksittisen osan myynti, kopiointi ja jakelu on kielletty.
# Ohjelmaa ei saa levitt tai kopioida ulkopuolisille. Erilaisten Internet- ja
# BBS-palveluiden sek ohjelmapakettien ja -levyjen kautta tapahtuva jakelu on mys
# kielletty. Mys ohjelmakoodin myynti, kopiointi ja levitys on kielletty.
#
# Ohjelman tekij ei vastaa mistn ohjelman asennuksesta, kytst tai poistosta
# mahdollisesti aiheutuvista vahingoista, ellei kirjallisesti ole toisin sovittu.
# Ohjelman asennus, poisto ja kytt ovat siis tysin sen kyttoikeuden haltijan
# vastuulla.
#
# Ohjelmaa kytettess sen ohjelmakoodiin ja HTML- yms. tiedostoihin mahdollisesti
# sisltyvt ohjelman tekijn tai hnen Internet-sivuihinsa viittaavat kuvat ja
# hyperlinkit on silytettv.
#
####################################################################################

$tuotenimi = "Sport LeagueResult System / Resulttia Solutions";
$tuoteversio = "1.0.20150301";

### TARVITTAVAT MUUTTUJAT ##########################################################

push @INC, "/var/www/customers/junnubilisliigafi/public_html/forum/";

require "asetukset.cgi";

@FORUMKATEGORIAT = ();

foreach $dir (@HAKEMISTO_FORUMNIMI)
{
  ($hak, $forumnimi, $suojattu) = split(/, /, $dir);
    
  if ($hak ne "" && $forumnimi ne "" && $suojattu ne "")
  {
    push @FORUMKATEGORIAT, "$dir";
  }
}

$parametrit = $ENV{QUERY_STRING};

# jos kyttjien on rekisteridyttv

if ($kayttajien_rekisteroidyttava == 1)
{
  $kommentti_alku = "";
  $kommentti_loppu = "";
}
else
{
  $kommentti_alku = "\<!-- ";
  $kommentti_loppu = " --\>";
}

### LUETAAN PARAMETRIT SELAIMEN OSOITERIVILT ######################################

if (! $parametrit) # tulostetaan foorumin etusivu, ts. tiedot keskustelukategorioista
{
  &tulosta_foorumin_etusivu;
}
elsif ($parametrit eq "toiminto=rekisterointi") # tulostetaan rekisterintilomake
{
  &tulosta_profiilin_rekisterointisivu;
}
elsif ($parametrit eq "toiminto=rekisteroidy") # tallennetaan rekisterintitiedot ja luodaan uusi profiili
{
  &rekisteroi_profiili;
}
elsif ($parametrit eq "toiminto=kirjaudu_profiilimuokkaukseen") # tulostetaan kirjautumissivu profiilimuokkaukseen
{
  &tulosta_profiilimuokkauksen_kirjautumissivu;
}
elsif ($parametrit eq "toiminto=profiili_muokattavaksi") # tulostetaan profiilitietojen muokkauslomake
{
  &tulosta_profiilin_muokkaussivu;
}
elsif ($parametrit eq "toiminto=muokkaa_profiilia") # tallennetaan muokatut profiilitiedot profiilitiedostoon
{
  &tallenna_muutokset_profiiliin;
}
elsif ($parametrit =~ /^poista_profiili=/ && $parametrit =~ /polku=/) # "poistetaan" rekisterityneen kyttjn profiilitiedosto
{
  &poista_profiilitiedosto;
}
elsif ($parametrit =~ /^paakayttaja=/ && $parametrit =~ /polku=/) # annetaan profiilille pkyttjn oikeudet
{
  $luokitus = "pkyttj";
  &muuta_profiilin_oikeuksia;
}
elsif ($parametrit =~ /^erikoiskayttaja=/ && $parametrit =~ /polku=/) # annetaan profiilille erikoiskyttjn oikeudet
{
  $luokitus = "erikoiskyttj";
  &muuta_profiilin_oikeuksia;
}
elsif ($parametrit =~ /^peruskayttaja=/ && $parametrit =~ /polku=/) # annetaan profiilille peruskyttjn oikeudet
{
  $luokitus = "peruskyttj";
  &muuta_profiilin_oikeuksia;
}
elsif ($parametrit =~ /^profiili=/ && $parametrit =~ /aika=/) # tulostetaan kyttjprofiilin tiedot sivulle
{
  &tulosta_profiilisivu;
}
elsif ($parametrit eq "toiminto=unohtunut_salasana") # tulostetaan lomake, jonka salasanans unohtanut saa tytt
{
  &tulosta_salasanalahetyssivu;
}
elsif ($parametrit eq "toiminto=laheta_salasana") # lhetetn unohtunut salasana shkpostitse
{
  &laheta_unohtunut_salasana;
}
elsif ($parametrit eq "toiminto=vastaa") # vastataan viestiin
{
  &vastaa_viestiin;
}
elsif ($parametrit =~ /^toiminto=uusi_aihe&kategoria=/) # tulostetaan lomake uuden aiheen aloittamista varten
{
  &tulosta_uusiaihelomake;
}
elsif ($parametrit eq "toiminto=uusi_aihe") # aloitetaan uusi aihe
{
  &aloita_uusi_aihe;
}
elsif ($parametrit =~ /^muokkaa=/ && $parametrit =~ /kategoria=/ && $parametrit =~ /polku=/) # tulostetaan lomake, jolla voi muokata viesti
{
  &tulosta_muokkauslomake;
}
elsif ($parametrit eq "toiminto=muokkaa_viestia") # tallennetaan muutokset viestiin
{
  &tallenna_muutokset_viestiin;
}
elsif ($parametrit =~ /^poista=/ && $parametrit =~ /kategoria=/ && $parametrit =~ /polku=/) # "poistetaan" aihe tai vastaus vastauksineen
{
  &poista_viestiketju;
}

elsif ($parametrit =~ /^siirra=/ && $parametrit =~ /kategoria=/ && $parametrit =~ /polku=/) # tulostetaan lomake, jolla voi siirt viestej
{
  &tulosta_siirtolomake;
}
elsif ($parametrit eq "toiminto=siirra_viestiketju") # siirretn aihe tai vastaus vastauksineen kategoriasta toiseen
{  
  &siirra_viestiketju;
}

elsif ($parametrit =~ /^kategoria=/ && $parametrit =~ /viesti=/) # tulostetaan lomake, jolla voi vastata tiettyyn viestiin
{
  &tulosta_vastauslomake;
}
elsif ($parametrit =~ /^kategoria=/ && $parametrit !~ /aihe=/) # tulostetaan valitun kategorian aiheet
{
  &tulosta_kategorian_aiheet;
}
elsif ($parametrit =~ /^kategoria=/ && $parametrit =~ /aihe=/) # tulostetaan valitun keskustelun viestiketju
{
  &tulosta_keskustelun_viestit;
}
elsif ($parametrit eq "toiminto=haku") # tulostetaan hakutulokset
{
  &haku;
}
else
{
  $virhe = "";
  $virhe = "Tapahtui odottamaton virhe.<br><br>Ole hyv ja ota yhteytt foorumin <a href=\"&#109;&#97;&#105;&#108;&#116;&#111;&#58;$paakayttajan_email\">pkyttjn</a>, kiitos.";
  &virhesivu;
}

# require suorittaa vain kerran, do joka kerta (esim. foreach-silmukan jokaisella kierroksella)

sub tulosta_foorumin_etusivu                      { require "sub_tulosta_foorumin_etusivu.cgi"; }
sub tulosta_mahdollinen_aihe                      { do "sub_tulosta_mahdollinen_aihe.cgi"; }
sub tulosta_kategorian_aiheet                     { require "sub_tulosta_kategorian_aiheet.cgi"; }
sub tulosta_keskustelun_viestit                   { require "sub_tulosta_keskustelun_viestit.cgi"; }
sub tulosta_vastauslomake                         { require "sub_tulosta_vastauslomake.cgi"; }
sub tulosta_muokkauslomake                        { require "sub_tulosta_muokkauslomake.cgi"; }
sub tallenna_muutokset_viestiin                   { require "sub_tallenna_muutokset_viestiin.cgi"; }
sub vastaa_viestiin                               { require "sub_vastaa_viestiin.cgi"; }
sub virhesivu                                     { require "sub_virhesivu.cgi"; }
sub ok_sivu                                       { require "sub_ok_sivu.cgi"; }
sub tulosta_profiilisivu                          { require "sub_tulosta_profiilisivu.cgi"; }
sub tulosta_profiilimuokkauksen_kirjautumissivu   { require "sub_tulosta_profiilimuokkauksen_kirjautumissivu.cgi"; }
sub tulosta_profiilin_muokkaussivu                { require "sub_tulosta_profiilin_muokkaussivu.cgi"; }
sub tallenna_muutokset_profiiliin                 { require "sub_tallenna_muutokset_profiiliin.cgi"; }
sub parsi_lomake                                  { require "sub_parsi_lomake.cgi"; }
sub tulosta_uusiaihelomake                        { require "sub_tulosta_uusiaihelomake.cgi"; }
sub aloita_uusi_aihe                              { require "sub_aloita_uusi_aihe.cgi"; }
sub tulosta_profiilin_rekisterointisivu           { require "sub_tulosta_profiilin_rekisterointisivu.cgi"; }
sub rekisteroi_profiili                           { require "sub_rekisteroi_profiili.cgi"; }
sub muuta_profiilin_oikeuksia                     { require "sub_muuta_profiilin_oikeuksia.cgi"; }
sub tulosta_salasanalahetyssivu                   { require "sub_tulosta_salasanalahetyssivu.cgi"; }
sub laheta_unohtunut_salasana                     { require "sub_laheta_unohtunut_salasana.cgi"; }
sub tulosta_siirtolomake                          { require "sub_tulosta_siirtolomake.cgi"; }
sub siirra_viestiketju                            { require "sub_siirra_viestiketju.cgi"; }
sub poista_viestiketju                            { require "sub_poista_viestiketju.cgi"; }
sub poista_profiilitiedosto                       { require "sub_poista_profiilitiedosto.cgi"; }
sub selvita_pva_ja_kellonaika                     { require "sub_selvita_pva_ja_kellonaika.cgi"; }
sub vertaa_viimeisimpaan_viestiin                 { require "sub_vertaa_viimeisimpaan_viestiin.cgi"; }
sub haku                                          { require "sub_haku.cgi"; }